#!/bin/sh

iterate()
{
	"$@" GX - bin/opera@@{SUFFIX}
	"$@" GX - bin/opera-widget-manager@@{SUFFIX}
	if ! $repackage
	then
		"$@" GX - bin/uninstall-opera@@{SUFFIX}
	fi
	"$@" NF 07a9a5976c97a18bf1abb69516437e37 lib/opera@@{SUFFIX}/gstreamer/plugins/libgstoperamatroska.so
	"$@" NF f6fc4c941908dae0b047648474095b28 lib/opera@@{SUFFIX}/gstreamer/plugins/libgstoperavp8.so
	"$@" NF 4dff55192583b3635efed02f9041149a lib/opera@@{SUFFIX}/liboperagtk.so
	"$@" NF 000b9331f9ae524fda398da86a0166a0 lib/opera@@{SUFFIX}/liboperakde4.so
	"$@" NX 1da8466a8d4071c417b1b27534ccdbd5 lib/opera@@{SUFFIX}/opera@@{SUFFIX}
	"$@" NX 7183cbaaa79290f5bd57c5d3ecfced20 lib/opera@@{SUFFIX}/operaplugincleaner
	"$@" NX 20c85cbcd3ec023ddeb63e16078bcb03 lib/opera@@{SUFFIX}/operapluginwrapper
	"$@" NF 0a8389b127c477aa2c55ee5d234473ca lib/opera@@{SUFFIX}/plugins/README
	"$@" PF 2d775e1dee4e17219d7e9bab28263ec6 share/applications/opera-browser@@{SUFFIX}.desktop
	"$@" PF c32d6b1cdaa99944767e83a59fe27b4d share/applications/opera-widget-installer@@{SUFFIX}.desktop
	"$@" PF bf9c8c97f9432e69936000fc9db64290 share/applications/opera-widget-manager@@{SUFFIX}.desktop
	"$@" NF 3214f080875748938ba060314b4f727d share/doc/opera@@{SUFFIX}/LGPL-2
	"$@" NF 6a6a8e020838b23406c81b19c1d46df6 share/doc/opera@@{SUFFIX}/LGPL-3
	"$@" NF cda9e71cc5683e10cadfb50753561c5a share/doc/opera@@{SUFFIX}/LICENSE
	"$@" NF c9996f43d681b457f038bfc8efeef28a share/doc/opera@@{SUFFIX}/README.gstreamer
	"$@" NF e86ae7a20a7bc688af75a10d628de734 share/icons/hicolor/128x128/apps/opera-browser@@{SUFFIX}.png
	"$@" NF a8364412e16fd47998b58733e5a17ce6 share/icons/hicolor/128x128/apps/opera-widget-manager@@{SUFFIX}.png
	"$@" LL ../mimetypes/opera-widget@@{SUFFIX}.png share/icons/hicolor/128x128/apps/opera-widget@@{SUFFIX}.png
	"$@" NF 272f6ee8bbad4dc7029d81286ca4763e share/icons/hicolor/128x128/mimetypes/opera-extension@@{SUFFIX}.png
	"$@" NF e67a11f466869d45bda53bdc9dbf4820 share/icons/hicolor/128x128/mimetypes/opera-unite-application@@{SUFFIX}.png
	"$@" NF a2ae615b486e32092225f672d436d799 share/icons/hicolor/128x128/mimetypes/opera-widget@@{SUFFIX}.png
	"$@" NF c3a9608cefc210c9e7823389c880a846 share/icons/hicolor/16x16/apps/opera-browser@@{SUFFIX}.png
	"$@" NF 63786cc7701894e2ed1cecad31f2f78e share/icons/hicolor/16x16/apps/opera-widget-manager@@{SUFFIX}.png
	"$@" LL ../mimetypes/opera-widget@@{SUFFIX}.png share/icons/hicolor/16x16/apps/opera-widget@@{SUFFIX}.png
	"$@" NF 87c5739d23920500c0815c88fcee8fb1 share/icons/hicolor/16x16/mimetypes/opera-extension@@{SUFFIX}.png
	"$@" NF 87a4cd99f0b1be41a1f6cfda5d57858a share/icons/hicolor/16x16/mimetypes/opera-unite-application@@{SUFFIX}.png
	"$@" NF 2bf861fe626ecd8480ed4f4b1d4f6086 share/icons/hicolor/16x16/mimetypes/opera-widget@@{SUFFIX}.png
	"$@" NF 6ed751290abb1877dc5f63d98d519388 share/icons/hicolor/22x22/apps/opera-browser@@{SUFFIX}.png
	"$@" NF a385010faaf3f4474e179b3e31e7dc4c share/icons/hicolor/22x22/apps/opera-widget-manager@@{SUFFIX}.png
	"$@" LL ../mimetypes/opera-widget@@{SUFFIX}.png share/icons/hicolor/22x22/apps/opera-widget@@{SUFFIX}.png
	"$@" NF b1aadfffe1a2a4cbc0769505f130f462 share/icons/hicolor/22x22/mimetypes/opera-extension@@{SUFFIX}.png
	"$@" NF 96f5a6bb62249a96b18a21e2620dcaf5 share/icons/hicolor/22x22/mimetypes/opera-unite-application@@{SUFFIX}.png
	"$@" NF a9c3ccc0b72ab3af8abd7e340e3c9918 share/icons/hicolor/22x22/mimetypes/opera-widget@@{SUFFIX}.png
	"$@" NF 69ec92d70839774813d2b947b64b6c47 share/icons/hicolor/24x24/apps/opera-browser@@{SUFFIX}.png
	"$@" NF 18da329a213cc3c61f44fe570d7fafe5 share/icons/hicolor/24x24/apps/opera-widget-manager@@{SUFFIX}.png
	"$@" LL ../mimetypes/opera-widget@@{SUFFIX}.png share/icons/hicolor/24x24/apps/opera-widget@@{SUFFIX}.png
	"$@" NF 70c1f737385a88bd616654ef23a187cc share/icons/hicolor/24x24/mimetypes/opera-extension@@{SUFFIX}.png
	"$@" NF 5de5a30096324d2fb9d48928d49912c3 share/icons/hicolor/24x24/mimetypes/opera-unite-application@@{SUFFIX}.png
	"$@" NF 588162e24d2bd73258d1bcecf62b7798 share/icons/hicolor/24x24/mimetypes/opera-widget@@{SUFFIX}.png
	"$@" NF 8252fceede693440b96be35f6065cde3 share/icons/hicolor/32x32/apps/opera-browser@@{SUFFIX}.png
	"$@" NF 7d64048682c5ea906e7ea281f4f12442 share/icons/hicolor/32x32/apps/opera-widget-manager@@{SUFFIX}.png
	"$@" LL ../mimetypes/opera-widget@@{SUFFIX}.png share/icons/hicolor/32x32/apps/opera-widget@@{SUFFIX}.png
	"$@" NF 852841f582f95cabb04992397fcc97ce share/icons/hicolor/32x32/mimetypes/opera-extension@@{SUFFIX}.png
	"$@" NF 7d861375334ea90d50f01bd84720f54e share/icons/hicolor/32x32/mimetypes/opera-unite-application@@{SUFFIX}.png
	"$@" NF 70b287cbe7a06465220692a15c9b9c13 share/icons/hicolor/32x32/mimetypes/opera-widget@@{SUFFIX}.png
	"$@" NF d0b315ea05750c1abb157042e56165d2 share/icons/hicolor/48x48/apps/opera-browser@@{SUFFIX}.png
	"$@" NF 6177835f1655a6a1441ebefe49f404ff share/icons/hicolor/48x48/apps/opera-widget-manager@@{SUFFIX}.png
	"$@" LL ../mimetypes/opera-widget@@{SUFFIX}.png share/icons/hicolor/48x48/apps/opera-widget@@{SUFFIX}.png
	"$@" NF 6b94ab4c0f32141dc889207cf3454c43 share/icons/hicolor/48x48/mimetypes/opera-extension@@{SUFFIX}.png
	"$@" NF 4e4670e50dc2cb2305abd6f526a82099 share/icons/hicolor/48x48/mimetypes/opera-unite-application@@{SUFFIX}.png
	"$@" NF 6471746ab02f81f91b2e08fc95db4aa4 share/icons/hicolor/48x48/mimetypes/opera-widget@@{SUFFIX}.png
	"$@" NF 52440fbe31989de381a04002fe54da6e share/icons/hicolor/scalable/apps/opera-browser@@{SUFFIX}.svg
	"$@" NF c8931b3343cbec2271105febad88ebfe share/icons/hicolor/scalable/apps/opera-widget-manager@@{SUFFIX}.svg
	"$@" LL ../mimetypes/opera-widget@@{SUFFIX}.svg share/icons/hicolor/scalable/apps/opera-widget@@{SUFFIX}.svg
	"$@" NF fe9c0b034eb8961565ee0c19efecc2cd share/icons/hicolor/scalable/mimetypes/opera-extension@@{SUFFIX}.svg
	"$@" NF 957818c8871b44f4b490a51f90134fa5 share/icons/hicolor/scalable/mimetypes/opera-unite-application@@{SUFFIX}.svg
	"$@" NF 71d72ea4945da5e60a0dcef66c28c319 share/icons/hicolor/scalable/mimetypes/opera-widget@@{SUFFIX}.svg
	"$@" PF 8f77ca5ebdba2fe357ae0b4783a3c00c share/man/man1/opera-widget-manager@@{SUFFIX}.1.gz
	"$@" PF 3db4e6b81d4c522c7b349eabf17261bb share/man/man1/opera@@{SUFFIX}.1.gz
	"$@" PF b855f4913d0d9a9f87de9ba39cef1669 share/mime/packages/opera-extension@@{SUFFIX}.xml
	"$@" PF b469ae97e76fabd30be19b507ea62bd9 share/mime/packages/opera-unite-application@@{SUFFIX}.xml
	"$@" PF cb799e7d0fdabcc4c0a465b12a81b625 share/mime/packages/opera-widget@@{SUFFIX}.xml
	"$@" NF 4cb674aa1c9f8653f6a46ab158a03a67 share/opera@@{SUFFIX}/defaults/bookmarks.adr
	"$@" NF 47c08d6696bb0c85d176ee56ff9bd2c7 share/opera@@{SUFFIX}/defaults/feedreaders.ini
	"$@" NF eff00befe1723a4742b9ae591170566c share/opera@@{SUFFIX}/defaults/filehandler.ini
	"$@" NF c8da3f671c192d7193d2c04e41586fea share/opera@@{SUFFIX}/defaults/font.ini
	"$@" LL ../../doc/opera@@{SUFFIX}/LICENSE share/opera@@{SUFFIX}/defaults/license.txt
	"$@" NF 7933fada7c9b825155fbc04f3c959ee1 share/opera@@{SUFFIX}/defaults/mailproviders.xml
	"$@" NF 0cb4ac60c1cf45bd08ec4d5d62da5c02 share/opera@@{SUFFIX}/defaults/plugin-ignore.ini
	"$@" NF 140888cfeb603e37cb6de4845debbf8e share/opera@@{SUFFIX}/defaults/pluginpath.ini
	"$@" NF 47488826163056c486afcdf5051b59a9 share/opera@@{SUFFIX}/defaults/public_domains.dat
	"$@" NF ccf1073b83b8665424cd542c40bf254e share/opera@@{SUFFIX}/defaults/search.ini
	"$@" NF 220d7f3f71483ae7231d652cfa03361a share/opera@@{SUFFIX}/defaults/standard_speeddial.ini
	"$@" NF 2ecfa381c2006b9db4143f4da84954e5 share/opera@@{SUFFIX}/defaults/standard_trusted_repositories.ini
	"$@" NF c98d21788ba4619a0a3bb41722142e45 share/opera@@{SUFFIX}/defaults/webmailproviders.ini
	"$@" NF 5978ba5d3fa29bb0f5b210cc8aad57e1 share/opera@@{SUFFIX}/defaults/xmlentities.ini
	"$@" NF 62aa163b7ef5a1a61ea93709041e2ba1 share/opera@@{SUFFIX}/encoding.bin
	"$@" NF 54f1497ac9cc9ffa04d52213be260559 share/opera@@{SUFFIX}/extra/missingplugin.svg
	"$@" NF 17700f8a405a78dc1afdf69679a3f85b share/opera@@{SUFFIX}/extra/missingpluginhover.svg
	"$@" NF 0547d144b3de633887a8657de0ee1779 share/opera@@{SUFFIX}/extra/svg-mo.dat
	"$@" NF 6ee58550670e206dc93e1b31a7da2c9f share/opera@@{SUFFIX}/extra/svg-mobd.dat
	"$@" NF 0ab7eca84c071dac25dafd3b4569d80f share/opera@@{SUFFIX}/extra/svg-sa.dat
	"$@" NF 23059c42a43dceded9122d8834aa43fe share/opera@@{SUFFIX}/extra/svg-sabd.dat
	"$@" NF f3747a59108df781e04305b1bee29574 share/opera@@{SUFFIX}/extra/svg-se.dat
	"$@" NF bcdb530c010ed72fe6096d46366c57f5 share/opera@@{SUFFIX}/extra/svg-sebd.dat
	"$@" NF 7a2db2de5211ab16a6712e4168d17ec7 share/opera@@{SUFFIX}/html40_entities.dtd
	"$@" NF 87803f0514670b96c73d4043cd3568c8 share/opera@@{SUFFIX}/lngcode.txt
	"$@" NF 2b5ae08a90cd2232814f1736814a512f share/opera@@{SUFFIX}/locale/be/be.lng
	"$@" NF acf3c13ca72b7fedda420a8e1e87870e share/opera@@{SUFFIX}/locale/be/bookmarks.adr
	"$@" NF 09485fb95f804e2d97b150228a8e5d93 share/opera@@{SUFFIX}/locale/be/search.ini
	"$@" NF 079fa750ef054b8ccd700be2a735ceb0 share/opera@@{SUFFIX}/locale/be/standard_speeddial.ini
	"$@" NF b3a194a274411d5a37826cb3be803351 share/opera@@{SUFFIX}/locale/bg/bg.lng
	"$@" NF fbaacb092f6fb389ba57f810d31792bd share/opera@@{SUFFIX}/locale/bg/bookmarks.adr
	"$@" NF efd08b91bc846a9f6b8df13b4ce63f75 share/opera@@{SUFFIX}/locale/bg/search.ini
	"$@" NF c18afb1126158890bab0e51db64d606e share/opera@@{SUFFIX}/locale/bg/standard_speeddial.ini
	"$@" NF 2218692cb6ccf82543756b594f1dd444 share/opera@@{SUFFIX}/locale/cs/bookmarks.adr
	"$@" NF 8de57cc4cc5812856eaebaf006603250 share/opera@@{SUFFIX}/locale/cs/cs.lng
	"$@" NF b74b3b5e88c59106de655816a903c7e3 share/opera@@{SUFFIX}/locale/cs/search.ini
	"$@" NF a0b5936994fa18f0fdee04c32dff64c9 share/opera@@{SUFFIX}/locale/cs/standard_speeddial.ini
	"$@" NF 2558b521340394944f9633d6a54f69a6 share/opera@@{SUFFIX}/locale/da/da.lng
	"$@" NF 6523c529e2b7503607bfa1b54398a01d share/opera@@{SUFFIX}/locale/de/bookmarks.adr
	"$@" NF e70b81c5da86973899346fa16c2fce9a share/opera@@{SUFFIX}/locale/de/de.lng
	"$@" NF dc88bf5996815c97e4cbec16d4914ed9 share/opera@@{SUFFIX}/locale/de/search.ini
	"$@" NF 1bc79ff7ba1f02bbe9e83d2d9fef3033 share/opera@@{SUFFIX}/locale/de/standard_speeddial.ini
	"$@" NF a583daa0fd36b84f296ee93ea53f69ab share/opera@@{SUFFIX}/locale/el/el.lng
	"$@" NF de7b89f83721003bbb56d81088565825 share/opera@@{SUFFIX}/locale/en-GB/bookmarks.adr
	"$@" NF 56e6afd77b864566491f6aef061060d0 share/opera@@{SUFFIX}/locale/en-GB/en-GB.lng
	"$@" NF 6ce3ace371f567ccce5417999ae59285 share/opera@@{SUFFIX}/locale/en-GB/search.ini
	"$@" NF 3eddd0d9e499db279a94e206254275f6 share/opera@@{SUFFIX}/locale/en-GB/standard_speeddial.ini
	"$@" NF 7f5bbe1a291f2a8429b804bc88a2e7c6 share/opera@@{SUFFIX}/locale/en/bookmarks.adr
	"$@" NF 9029cfed3864dca3b2604a61e816cb70 share/opera@@{SUFFIX}/locale/en/en.lng
	"$@" NF 4965aac2f1c05d29608b784b565c347d share/opera@@{SUFFIX}/locale/en/en.zip
	"$@" LL ../../../doc/opera@@{SUFFIX}/LICENSE share/opera@@{SUFFIX}/locale/en/license.txt
	"$@" NF 648f27d4581c05cfa53c875d49a26a74 share/opera@@{SUFFIX}/locale/en/search.ini
	"$@" NF 3eddd0d9e499db279a94e206254275f6 share/opera@@{SUFFIX}/locale/en/standard_speeddial.ini
	"$@" NF 8cc0d49d5de699a46581f1e9a07c8c90 share/opera@@{SUFFIX}/locale/es-ES/bookmarks.adr
	"$@" NF 6e49e2726138c5dc2136dadefefaca9a share/opera@@{SUFFIX}/locale/es-ES/es-ES.lng
	"$@" NF 88601688160bd6403d93ebfc4044e36e share/opera@@{SUFFIX}/locale/es-ES/search.ini
	"$@" NF c878edc1c3716343c68ba29e2563fe5a share/opera@@{SUFFIX}/locale/es-ES/standard_speeddial.ini
	"$@" NF c9a4bf8d85561e2a1268b90ce957caa8 share/opera@@{SUFFIX}/locale/es-LA/es-LA.lng
	"$@" NF fb6ee257b44546d66cbe5ee0d568b432 share/opera@@{SUFFIX}/locale/et/et.lng
	"$@" NF 80ce5d1a5c0389b2fc410707c01bb886 share/opera@@{SUFFIX}/locale/fi/fi.lng
	"$@" NF 23b9af59bb1b58706794bb5b0c863f01 share/opera@@{SUFFIX}/locale/fr-CA/fr-CA.lng
	"$@" NF 111b339f00ca3b3aca44993f09e4fa03 share/opera@@{SUFFIX}/locale/fr/bookmarks.adr
	"$@" NF 715fee0ab8d3d9c1aa91e644da9974cb share/opera@@{SUFFIX}/locale/fr/fr.lng
	"$@" NF 95d5232173e3506c2ecd62b39ed7398f share/opera@@{SUFFIX}/locale/fr/search.ini
	"$@" NF 0ddeb68a376026610c0c282258d77480 share/opera@@{SUFFIX}/locale/fr/standard_speeddial.ini
	"$@" NF a8667122570db70cf2007901814dbcb6 share/opera@@{SUFFIX}/locale/fy/fy.lng
	"$@" NF 835846c29051e1c163463425264c5915 share/opera@@{SUFFIX}/locale/gd/gd.lng
	"$@" NF 49b8b8991273fb466d70ba6886bb345f share/opera@@{SUFFIX}/locale/hi/hi.lng
	"$@" NF 6422217ba1fec3cd546cf56cf8fac8d9 share/opera@@{SUFFIX}/locale/hr/hr.lng
	"$@" NF bc176094b5455b35042c535de6c99531 share/opera@@{SUFFIX}/locale/hu/bookmarks.adr
	"$@" NF 6092fb5c8c00916398868fbce84b962b share/opera@@{SUFFIX}/locale/hu/hu.lng
	"$@" NF 1757fd22407bee5fe22bc1bb3a6472c3 share/opera@@{SUFFIX}/locale/hu/search.ini
	"$@" NF bac45114266b5062c12b95189c51abc9 share/opera@@{SUFFIX}/locale/hu/standard_speeddial.ini
	"$@" NF 4e8f23fa3debebac82fd9e41efded1c8 share/opera@@{SUFFIX}/locale/id/id.lng
	"$@" NF bbd6ee592eb08fa0019f5bf9a95664f7 share/opera@@{SUFFIX}/locale/it/bookmarks.adr
	"$@" NF 7779d9d26baa966bcf1a1d8e114c0186 share/opera@@{SUFFIX}/locale/it/it.lng
	"$@" NF 905ef5be837a0fed3e83344a27b0516f share/opera@@{SUFFIX}/locale/it/search.ini
	"$@" NF 4a094ba0a0d4db9315288e407cdd3bda share/opera@@{SUFFIX}/locale/it/standard_speeddial.ini
	"$@" NF 5e87f4e8391f055ffce6fbf64ae0d542 share/opera@@{SUFFIX}/locale/ja/bookmarks.adr
	"$@" NF d6cb96de84bf490064cd6f966dfd8b9d share/opera@@{SUFFIX}/locale/ja/ja.lng
	"$@" LL ../../../doc/opera@@{SUFFIX}/LICENSE share/opera@@{SUFFIX}/locale/ja/license.txt
	"$@" NF e852d7ee6c0ad8c4ee7b5d9cee7a5d09 share/opera@@{SUFFIX}/locale/ja/search.ini
	"$@" NF 316bfbe485b0d21b28a262517943cdb9 share/opera@@{SUFFIX}/locale/ja/standard_speeddial.ini
	"$@" NF 5abb4911343d9fc074de8ac3525a554b share/opera@@{SUFFIX}/locale/ka/ka.lng
	"$@" NF 30b0a7a775bca733e44d164491b40bb4 share/opera@@{SUFFIX}/locale/ko/ko.lng
	"$@" NF 33dc12ceb9121d05e00acd1d90e0f03d share/opera@@{SUFFIX}/locale/lt/lt.lng
	"$@" NF 5fd8c0bcc2fde3fda5ce258d4d563993 share/opera@@{SUFFIX}/locale/mk/mk.lng
	"$@" NF 1be92569b91543f3e5048bd2da8761a9 share/opera@@{SUFFIX}/locale/nb/bookmarks.adr
	"$@" NF c8ee2000a1c0331d374d0f86aeeabf39 share/opera@@{SUFFIX}/locale/nb/nb.lng
	"$@" NF 47c329b8456b3953c95ae42092b325a0 share/opera@@{SUFFIX}/locale/nb/search.ini
	"$@" NF f4859c597659c94c2ec0cdaa7844c541 share/opera@@{SUFFIX}/locale/nb/standard_speeddial.ini
	"$@" NF 13a60814261b967bab88270be3ed343e share/opera@@{SUFFIX}/locale/nl/nl.lng
	"$@" NF 8b6308621d2c4318fa2cb845493fca38 share/opera@@{SUFFIX}/locale/nn/nn.lng
	"$@" NF c47de3617bab1089287c4d13484ea707 share/opera@@{SUFFIX}/locale/pl/bookmarks.adr
	"$@" NF 5a744b720dc7d08614b1423702db31f4 share/opera@@{SUFFIX}/locale/pl/pl.lng
	"$@" NF 5446bae7bf0f454b522c60a6b89ee5a8 share/opera@@{SUFFIX}/locale/pl/search.ini
	"$@" NF 373456703477e02952ef69840b12e102 share/opera@@{SUFFIX}/locale/pl/standard_speeddial.ini
	"$@" NF cec18b606aecbc288a77cbfe6bf12d5c share/opera@@{SUFFIX}/locale/pt-BR/pt-BR.lng
	"$@" NF 123aca479df5935bd7f997c380e32cfa share/opera@@{SUFFIX}/locale/pt/pt.lng
	"$@" NF 7b95d32fd40dfb0471a9badd405abefc share/opera@@{SUFFIX}/locale/ro/bookmarks.adr
	"$@" NF 4713b5d4e10401d43b29e70563009888 share/opera@@{SUFFIX}/locale/ro/ro.lng
	"$@" NF 9e9037c1372d694cd239ee2d14ad427c share/opera@@{SUFFIX}/locale/ro/search.ini
	"$@" NF c18afb1126158890bab0e51db64d606e share/opera@@{SUFFIX}/locale/ro/standard_speeddial.ini
	"$@" NF 0a5cac557374d7088f26cf7b0f787053 share/opera@@{SUFFIX}/locale/ru/bookmarks.adr
	"$@" NF f69e5cb960444387d912494da006d829 share/opera@@{SUFFIX}/locale/ru/ru.lng
	"$@" NF 52f20f20d1bdc59ded37126b32de0364 share/opera@@{SUFFIX}/locale/ru/search.ini
	"$@" NF d40c31d587e745f4301d7cab2e298938 share/opera@@{SUFFIX}/locale/ru/standard_speeddial.ini
	"$@" NF 00143eebb2330e52ae4ec7d2dd881a8a share/opera@@{SUFFIX}/locale/sk/bookmarks.adr
	"$@" NF 7047590837f086dfdd0be503cdadf6bf share/opera@@{SUFFIX}/locale/sk/search.ini
	"$@" NF efb80a0874b1e24a925cc647b8f25b4c share/opera@@{SUFFIX}/locale/sk/sk.lng
	"$@" NF 187257ab1a878c21c957decb1fea9f05 share/opera@@{SUFFIX}/locale/sk/standard_speeddial.ini
	"$@" NF 4b674679dcc365056133fc7d34ba87f3 share/opera@@{SUFFIX}/locale/sr/bookmarks.adr
	"$@" NF c9378abc6e0265f85c835ef5b2bdf0f9 share/opera@@{SUFFIX}/locale/sr/search.ini
	"$@" NF d37022f5fae5c8ea1e3c30e89230dc1f share/opera@@{SUFFIX}/locale/sr/sr.lng
	"$@" NF c18afb1126158890bab0e51db64d606e share/opera@@{SUFFIX}/locale/sr/standard_speeddial.ini
	"$@" NF ecabcd77aa33aad7e20abd71b903e5b7 share/opera@@{SUFFIX}/locale/sv/sv.lng
	"$@" NF 404af98fac30a3bf9dce28e997b0d41d share/opera@@{SUFFIX}/locale/ta/ta.lng
	"$@" NF c1950e3b614b970b5f17e4dec8fb608c share/opera@@{SUFFIX}/locale/te/te.lng
	"$@" NF 50c4ee63a0a8d23594a586e21b3bbbe9 share/opera@@{SUFFIX}/locale/tr/tr.lng
	"$@" NF a1c5522fee2230561baf68bd86681949 share/opera@@{SUFFIX}/locale/uk/bookmarks.adr
	"$@" NF 21b15d82d425fb4e6ddfbe262e9ebbb9 share/opera@@{SUFFIX}/locale/uk/search.ini
	"$@" NF 8beaab8ab5f5af7f0b9e52b31b35bea1 share/opera@@{SUFFIX}/locale/uk/standard_speeddial.ini
	"$@" NF 5c8e604538ae5746250ac8d2c1bc2260 share/opera@@{SUFFIX}/locale/uk/uk.lng
	"$@" NF b4af7244bc743468d3ff2f2ed461d361 share/opera@@{SUFFIX}/locale/vi/vi.lng
	"$@" NF 8e809f73f283b7e60d934753d9120b0e share/opera@@{SUFFIX}/locale/zh-cn/bookmarks.adr
	"$@" NF 95484d8263e8d2203ac7975d0378af37 share/opera@@{SUFFIX}/locale/zh-cn/browser.js
	"$@" NF ed6402982b9540ec7aa8274168a8e9e4 share/opera@@{SUFFIX}/locale/zh-cn/search.ini
	"$@" NF fa3dcf7fa65c11de3faa0f4fe6319ef2 share/opera@@{SUFFIX}/locale/zh-cn/standard_speeddial.ini
	"$@" NF d44fc31b4c96a97d22624455874764ca share/opera@@{SUFFIX}/locale/zh-cn/turbosettings.xml
	"$@" NF a3df890d10c7c575aac6b531dd19bf57 share/opera@@{SUFFIX}/locale/zh-cn/zh-cn.lng
	"$@" NF 95484d8263e8d2203ac7975d0378af37 share/opera@@{SUFFIX}/locale/zh-hk/browser.js
	"$@" NF 6ea2f98cdeaf54c398dca24aea9df644 share/opera@@{SUFFIX}/locale/zh-hk/turbosettings.xml
	"$@" NF 95484d8263e8d2203ac7975d0378af37 share/opera@@{SUFFIX}/locale/zh-tw/browser.js
	"$@" NF 6ea2f98cdeaf54c398dca24aea9df644 share/opera@@{SUFFIX}/locale/zh-tw/turbosettings.xml
	"$@" NF b191107864a1412a0a2fb8618ea63d9f share/opera@@{SUFFIX}/locale/zh-tw/zh-tw.lng
	"$@" NF 1c24deadc6027ab1b7a2cecc7b7c00e4 share/opera@@{SUFFIX}/mathml.dtd
	"$@" NF 1776a26737c607184a94f14821e2e530 share/opera@@{SUFFIX}/package-id.ini
	"$@" NF a6485d9b7be876314c624d291d6575a1 share/opera@@{SUFFIX}/package/lib/binprint.sh
	"$@" NF e7e881f582f55beb206ee28c694a9a1c share/opera@@{SUFFIX}/package/lib/layout_common.sh
	"$@" NF 45642baaad2a785da620edf0945690ff share/opera@@{SUFFIX}/package/lib/layout_deb.sh
	"$@" NF ef97aabff0bf409a1b8869d34668d727 share/opera@@{SUFFIX}/package/lib/layout_tar.sh
	"$@" NF a8282806a1e3b9bea0f279348f76d4c2 share/opera@@{SUFFIX}/package/lib/main.sh
	"$@" NF 5843ecaae9aad7e1e0f36bc0d245df45 share/opera@@{SUFFIX}/package/lib/normalize.sh
	"$@" NF 324d47f2b5cf6e64fc7b548883527d5f share/opera@@{SUFFIX}/package/lib/package_deb.sh
	"$@" NF f809760b9a5cce32e0dd95e0fd39eb36 share/opera@@{SUFFIX}/package/lib/package_rpm.sh
	"$@" NF bd8cc8ab3353a0c14c514fb25f74302f share/opera@@{SUFFIX}/package/lib/package_tar.sh
	"$@" NF b2a6eb60c20b9329acad9f519ca66ac0 share/opera@@{SUFFIX}/package/lib/xml.sh
	"$@" NX bca998e6f24510a22be340fea94f81f0 share/opera@@{SUFFIX}/package/main.sh
	"$@" NF 7596341331a010f3e5c27d70405cc304 share/opera@@{SUFFIX}/skin/standard_skin.zip
	"$@" NF 5f6310213a659ef90ab86585115d12e1 share/opera@@{SUFFIX}/skin/unix_skin.zip
	"$@" NF 06820e6bdd581b0a257e5e2648360457 share/opera@@{SUFFIX}/styles/about.css
	"$@" NF 4fb7c857524fd084449266fc70e9288b share/opera@@{SUFFIX}/styles/cache.css
	"$@" NF 8295c14370590319f3f116b0e8b358ec share/opera@@{SUFFIX}/styles/certinfo.css
	"$@" NF 37a280b560c9c26fdf1ca5e6b616901f share/opera@@{SUFFIX}/styles/config.css
	"$@" NF adc83d14afaa0ea76588cf340e36c3a5 share/opera@@{SUFFIX}/styles/contentblock.css
	"$@" NF 3ddaf96398ae99245f6b83e6dc676ac6 share/opera@@{SUFFIX}/styles/debug.css
	"$@" NF 056873687942e8aad4f0f297c1d4a57b share/opera@@{SUFFIX}/styles/dir.css
	"$@" NF fb8d712239bbe69e40c6c213f4fb47a2 share/opera@@{SUFFIX}/styles/error.css
	"$@" NF e9ee42b5c66c0367c1e02a1eeeca0776 share/opera@@{SUFFIX}/styles/history.css
	"$@" NF 3313969be29b130922a2551034194d42 share/opera@@{SUFFIX}/styles/im.css
	"$@" NF c8723eaa9387b79cf23f8f49c8bdb5b3 share/opera@@{SUFFIX}/styles/image.css
	"$@" NF 73b840d67b16a49008b7ed3d6aec38ab share/opera@@{SUFFIX}/styles/images/Opera_256x256.png
	"$@" NF 35a8968b802c4cd66f70631354cec397 share/opera@@{SUFFIX}/styles/images/bar.png
	"$@" NF 2e242ddd9c9679c584b0fe430b8948cf share/opera@@{SUFFIX}/styles/images/bkgd-rev.png
	"$@" NF b133b79753e118bafa077c594ed22724 share/opera@@{SUFFIX}/styles/images/bkgd.png
	"$@" NF 4289d8db3e0ad4cb825d34c969c142ff share/opera@@{SUFFIX}/styles/images/bullet.png
	"$@" NF cbdbb7032558dae6b04f7691c4b8a41a share/opera@@{SUFFIX}/styles/images/center.png
	"$@" NF f23a4e2a5c1a0db7cfac79d1e7b9ba23 share/opera@@{SUFFIX}/styles/images/corner.png
	"$@" NF b423f4149c868ccf56a15abb83228f09 share/opera@@{SUFFIX}/styles/images/customize.gif
	"$@" NF e715da6d7e5314261bdff2942251718a share/opera@@{SUFFIX}/styles/images/darkBox.png
	"$@" NF 0dfc37ae4404b4a6811e4876db6b7df1 share/opera@@{SUFFIX}/styles/images/defaultFavicon.png
	"$@" NF 71bbdb354d7e65183c86aa36a27ddd1d share/opera@@{SUFFIX}/styles/images/error.png
	"$@" NF ac4455a870ed9d5365377c2d9566240c share/opera@@{SUFFIX}/styles/images/file.png
	"$@" NF 86c6ac920bd2fbb7f538ff79d4e34395 share/opera@@{SUFFIX}/styles/images/flag.png
	"$@" NF c6ee6872a8d70dbec976edd11bdaf986 share/opera@@{SUFFIX}/styles/images/folder.png
	"$@" NF 4412303b131452fd536e794e93bdc8f5 share/opera@@{SUFFIX}/styles/images/hanger.png
	"$@" NF cd587bbd0135bcc9820de23318dbae41 share/opera@@{SUFFIX}/styles/images/header-expanded.png
	"$@" NF 533450be6ceff816d25c53fb8ca93cad share/opera@@{SUFFIX}/styles/images/header.png
	"$@" NF 0c313c9e4b635e06cc9fa61b734ad99b share/opera@@{SUFFIX}/styles/images/opera-icon-red.png
	"$@" NF bfdd24b5079de6de555f5477256a8ed3 share/opera@@{SUFFIX}/styles/images/opera-icon-white.png
	"$@" NF a2ed905f3862c320bb43e866721729d7 share/opera@@{SUFFIX}/styles/images/opera.png
	"$@" NF dbb6d41150a244186500718eda971047 share/opera@@{SUFFIX}/styles/images/page-bot.png
	"$@" NF d58ef56a726e38bb51da5adf696153fc share/opera@@{SUFFIX}/styles/images/red_center.png
	"$@" NF 3c6c895d2519efa918b4b3f46a897b67 share/opera@@{SUFFIX}/styles/images/red_left.png
	"$@" NF a28ba91c09ea75605d727e9bde7771b1 share/opera@@{SUFFIX}/styles/images/red_right.png
	"$@" NF a0c5f8a66f4e25f5d16ca1696a8f2e03 share/opera@@{SUFFIX}/styles/images/root.png
	"$@" NF 4aecd261352501fa1bad2c5e608df556 share/opera@@{SUFFIX}/styles/images/search.png
	"$@" NF b641cb9df6a4065ec64e6aac43cd5bc8 share/opera@@{SUFFIX}/styles/images/section.png
	"$@" NF 62f6287d95fafa0a8c56287e41760f33 share/opera@@{SUFFIX}/styles/images/smartGroup.png
	"$@" NF 2dab1572b02772c7a4fea3b5d51d1c48 share/opera@@{SUFFIX}/styles/images/tooltiptail.png
	"$@" NF f4dbc8a7b78e98448ad509bedca371c1 share/opera@@{SUFFIX}/styles/images/top.png
	"$@" NF 074b5a2c5386b6f2d12d172aa2f349fa share/opera@@{SUFFIX}/styles/images/warning.png
	"$@" NF 3a1f01c2181d79f8d579d26ca8c36b0e share/opera@@{SUFFIX}/styles/info.css
	"$@" NF e521ce4a0e2ad947af55f2fec3e30aee share/opera@@{SUFFIX}/styles/m2_welcome_message.mbs
	"$@" NF 174c0ece627639181db1815bff4f2f06 share/opera@@{SUFFIX}/styles/mail.css
	"$@" NF c92ea7dc91d7147ae4c5f51be8e9bf1e share/opera@@{SUFFIX}/styles/mathml.css
	"$@" NF 9f1492e55cf8d27f126607cd97bb4f8e share/opera@@{SUFFIX}/styles/media.css
	"$@" NF e7dd3d81e0088d5fb56df880226cc7e1 share/opera@@{SUFFIX}/styles/message.css
	"$@" NF 3750093c67f26b7815262956cc5c5652 share/opera@@{SUFFIX}/styles/mime.css
	"$@" NF 9a2650a6f6b3ec7c876cf0630394db37 share/opera@@{SUFFIX}/styles/opera.css
	"$@" NF 77f475917c73883ae464e47aaa6c9314 share/opera@@{SUFFIX}/styles/plugins.css
	"$@" NF 4f25b1757ad75536fd6811254e7e4e64 share/opera@@{SUFFIX}/styles/private.css
	"$@" NF 028e214f2f1147678d50afc03705e7de share/opera@@{SUFFIX}/styles/search.css
	"$@" NF 4a1307a5ef44ce6f2699910d68353aaf share/opera@@{SUFFIX}/styles/unstyledxml.css
	"$@" NF 5bc0a8abcf1f533070d01415ecd7ad18 share/opera@@{SUFFIX}/styles/user/accessibility.css
	"$@" NF 0543fa1f23163fda70da1abca48ab27b share/opera@@{SUFFIX}/styles/user/altdebugger.css
	"$@" NF 83c445d3d83311a72e2b20ae3bcc31d2 share/opera@@{SUFFIX}/styles/user/classid.css
	"$@" NF 2fa6fc6187625a9b18f593bc0155347d share/opera@@{SUFFIX}/styles/user/contrastbw.css
	"$@" NF 3b14649c488639ccb271f4062fdbdbc3 share/opera@@{SUFFIX}/styles/user/contrastwb.css
	"$@" NF 768fce2463be25592a7a18cf5de76dd5 share/opera@@{SUFFIX}/styles/user/disablebreaks.css
	"$@" NF df59e1efbfe9e9e693007379ae36c7c7 share/opera@@{SUFFIX}/styles/user/disablefloats.css
	"$@" NF b219720e32060eae7275b10f89822044 share/opera@@{SUFFIX}/styles/user/disableforms.css
	"$@" NF ff377988948f88b59d786eb4b4f5f6bd share/opera@@{SUFFIX}/styles/user/disablepositioning.css
	"$@" NF a282ab27760ce5c9d08e5d19e3679f45 share/opera@@{SUFFIX}/styles/user/disabletables.css
	"$@" NF a89f5a95b9d93f02a5710a015e0eb1fa share/opera@@{SUFFIX}/styles/user/outline.css
	"$@" NF 1641b9745dcd076b4850bc79a5e3a745 share/opera@@{SUFFIX}/styles/user/structureblock.css
	"$@" NF 04db12198eb3e12f3fdb9818aff46cd7 share/opera@@{SUFFIX}/styles/user/structureinline.css
	"$@" NF b32564a2bc51123644e04b434c70d24b share/opera@@{SUFFIX}/styles/user/structuretables.css
	"$@" NF 76eadfb729094d536d2313e62ec5f02b share/opera@@{SUFFIX}/styles/user/tablelayout.css
	"$@" NF 0247352ff07de9a6f4a9ea9661fe54a9 share/opera@@{SUFFIX}/styles/user/toc.css
	"$@" NF a2fafb8c2521c958c3fbc5e49230e349 share/opera@@{SUFFIX}/styles/warning.css
	"$@" NF 674df2f111e88c15ed2db3b021cfbcd6 share/opera@@{SUFFIX}/styles/webfeeds.html
	"$@" NF a58d7f0685e93c12befea0abf0c168ef share/opera@@{SUFFIX}/styles/webstorage.css
	"$@" NF ff04b782043ab4c4b1b0d4114901af21 share/opera@@{SUFFIX}/styles/wml.css
	"$@" NF 1889ba865f1cc800e7095af2d27a3126 share/opera@@{SUFFIX}/ui/dialog.ini
	"$@" NF e6d9e74c12773dcf0d6a195b6b9e78ac share/opera@@{SUFFIX}/ui/fastforward.ini
	"$@" NF 4213e1b92c598fd0670a95b8cbd297c1 share/opera@@{SUFFIX}/ui/standard_keyboard.ini
	"$@" NF f5e6add8ee0fa9463be1df7cae93fdf8 share/opera@@{SUFFIX}/ui/standard_keyboard_compat.ini
	"$@" NF 83a2ff858c53e71046cc4d75c8ea9412 share/opera@@{SUFFIX}/ui/standard_menu.ini
	"$@" NF 942a4cf89c0f15f20744dc91431876fd share/opera@@{SUFFIX}/ui/standard_mouse.ini
	"$@" NF d22c71ab3792a87e0f1dc640b54bcc6b share/opera@@{SUFFIX}/ui/standard_toolbar.ini
	"$@" NF cb7dc4aea35611d8f4ad044e2091be8b share/opera@@{SUFFIX}/ui/unix_keyboard.ini
	"$@" NF 3a1fb133feaee4e485105920c6df90d8 share/opera@@{SUFFIX}/unite/fileSharing.ua
	"$@" NF 943af9aa450c12748605166dae86adf0 share/opera@@{SUFFIX}/unite/fridge.ua
	"$@" NF 3ba15e7cf7a41404efe4077ba7053394 share/opera@@{SUFFIX}/unite/home.ua
	"$@" NF 8d80b7da73a0c04d216a2c6c8118a485 share/opera@@{SUFFIX}/unite/mediaPlayer.ua
	"$@" NF db50994e29503bdff144eb571b07d954 share/opera@@{SUFFIX}/unite/messenger.ua
	"$@" NF 942fb3b7ec876bc262aaf1a57d7bb98a share/opera@@{SUFFIX}/unite/photoSharing.ua
	"$@" NF 472da74591a22646a2b61b321814f3ba share/opera@@{SUFFIX}/unite/webserver.ua
}

available()
{
	command -v "$1" >/dev/null 2>&1
}

finalize_desktop()
{
	# Menu entries
	if available update-desktop-database
	then
		update-desktop-database $PREFIX/share/applications
	fi

	# MIME associations
	if available update-mime-database
	then
		mkdir -p $PREFIX/share/mime/packages
		update-mime-database $PREFIX/share/mime
		! rmdir $PREFIX/share/mime/packages >/dev/null 2>&1
	fi

	# Icons
	touch -c $PREFIX/share/icons/hicolor
	if available update-icon-caches
	then
		update-icon-caches -tq $PREFIX/share/icons/hicolor
	elif available gtk-update-icon-cache
	then
		gtk-update-icon-cache -tq $PREFIX/share/icons/hicolor
	fi
}

make_tempdir()
{
	if [ -z "$tempdir" ]
	then
		tempdir=$(mktemp -d -t opera-install.XXXXXXXX)
		if [ $? != 0 ]
		then
			ui_error "Cannot create a temporary directory, please set TMPDIR correctly"
		fi
	fi
}

cleanup()
{
	res=$?
	trap - 0
	if [ $res -gt 0 ] && $need_rollback
	then
		rollback
	fi
	if $need_ui_cleanup
	then
		ui_cleanup
	fi
	if [ -n "$tempdir" ]
	then
		rm -rf $tempdir
	fi
	exit $res
}

ui_widget()
{
	local width height
	message=$(
		echo "$2"
		if [ -n "$3" ]
		then
			echo
			cat "$3"
		fi
		if [ -n "$4" ]
		then
			echo
			echo "$4"
		fi
	)
	case $driver in
		dialog|whiptail)
			width=72
			if available fmt
			then
				message=$(echo "$message" | fmt -w $((width - 4)))
				height=$(($(echo "$message" | wc -l) + 6))
				if [ $1 = inputbox ]
				then
					height=$((height + 2))
				fi
			else
				height=20
			fi
			;;
	esac
	need_ui_cleanup=true
	case $driver in
		dialog|whiptail)
			exec 4>&1
			answer=$($driver --title "$windowtitle" --clear --$1 "$message" $height $width 2>&1 1>&4)
			res=$?
			exec 4>&-
			;;
		plain)
			echo
			echo "$message"
			case $1 in
				yesno)
					while true
					do
						read -p 'Please enter Y or N: ' answer
						case "$answer" in
							y*|Y*)
								res=0
								break
								;;
							n*|N*)
								res=1
								break
								;;
						esac
					done
					;;
				inputbox)
					read -p '>' answer
					;;
				msgbox|infobox)
					res=0
					;;
			esac
			;;
	esac
	need_ui_cleanup=false
	return $res
}

ui_info()
{
	ui_widget infobox "$@"
}

ui_message()
{
	ui_widget msgbox "$@"
}

ui_warn()
{
	ui_widget yesno "$1" "$2" 'Continue?' || exit
}

ui_error()
{
	ui_widget msgbox "$1" "$2" 'Installation aborted.'
	exit 1
}

ui_input()
{
	ui_widget inputbox "$1" "$2" ''
}

ui_menu()
{
	local text width height
	case $driver in
		dialog|whiptail)
			width=72
			if available fmt
			then
				height=$(($(echo "$text" | fmt -w $((width - 4)) | wc -l) + $# / 2 + 8))
			else
				height=20
			fi
			;;
	esac
	need_ui_cleanup=true
	case $driver in
		dialog|whiptail)
			text=$1
			shift
			exec 4>&1
			answer=$($driver --menu "$text" $height $width $(($# / 2)) "$@" 2>&1 1>&4) || exit
			res=$?
			exec 4>&-
			;;
		plain)
			echo
			echo "$1"
			shift
			(
				n=1
				while [ -n "$1" ]
				do
					echo "[$n] $2"
					n=$((n + 1))
					shift 2
				done
			)
			while true
			do
				read -p "Your choice: " answer
				if echo "$answer" | grep -q '^[0-9][0-9]*$' && [ $((answer >= 1)) = 1 ] && [ $((answer <= $# / 2)) = 1 ]
				then
					break
				fi
				echo "Please enter an integer between 1 and $(($# / 2))."
			done
			shift $((answer * 2 - 2))
			answer="$1"
			res=0
			;;
	esac
	need_ui_cleanup=false
	return $res
}

ui_progress_begin()
{
	if ! $talk
	then
		return
	fi
	if [ -z "$progress_max" ]
	then
		progress_max=$(iterate echo | wc -l)
	fi
	progress_cur=0
	need_ui_cleanup=true
	case $driver in
		whiptail)
			make_tempdir
			mkfifo $tempdir/gauge
			whiptail --gauge "$1" 0 72 0 <$tempdir/gauge &
			exec 3>$tempdir/gauge
			;;
		*)
			echo
			echo -n "$1"
			;;
	esac
}

ui_progress_advance()
{
	if ! $talk
	then
		return
	fi
	progress_cur=$((progress_cur + 1))
	case $driver in
		whiptail)
			echo $((progress_cur * 100 / progress_max)) >&3
			;;
		*)
			echo -n '.'
			;;
	esac
}

ui_progress_end()
{
	if ! $talk
	then
		return
	fi
	case $driver in
		whiptail)
			exec 3>&-
			rm $tempdir/gauge
			;;
		*)
			echo 'done'
			;;
	esac
	need_ui_cleanup=false
}

ui_cleanup()
{
	case $driver in
		dialog)
			exec 4>&-
			dialog --clear
			stty sane
			clear
			;;
		whiptail)
			exec 3>&- 4>&-
			stty sane
			clear
			;;
		plain)
			echo
			;;
	esac
}

ui_init()
{
	if [ -z "$TERM" -o "$TERM" = dumb ]
	then
		driver=plain
	elif available whiptail
	then
		driver=whiptail
	elif available dialog
	then
		driver=dialog
	else
		driver=plain
	fi
	answer=''
	progress_max=''
	windowtitle="$1"
}

common_init()
{
	interactive=true
	talk=true
	force=false
	need_rollback=false
	need_ui_cleanup=false
	repackage=false
	tempdir=''

	trap cleanup 0 INT QUIT TERM
}

common_opt()
{
	case "$1" in
		--text)
			driver=plain
			;;
		--unattended)
			interactive=false
			driver=plain
			;;
		--quiet)
			talk=false
			interactive=false
			driver=plain
			;;
		--force)
			force=true
			;;
		*)
			return 1
	esac
}

# EOF_COMMON

version()
{
	ui_message "This script installs Opera 11.01 build 1175 for Linux on i386.

Copyright (c) 1995-2011 Opera Software ASA. All rights reserved."
}

usage()
{
	version
	cat <<EOF

Options:

    --text          Select plain-text user interface.

    --unattended    Ask no questions. Implies --text.
                    The --prefix option becomes mandatory. 

    --quiet         Ask no questions and don't show progress.
                    Implies --text.

    --prefix /P     Specify installation directory. Opera will be
                    installed into /P/bin, /P/share and /P/lib.

    --user          Install for the current user. Default for non-root.
                    Alias for --prefix $HOME/.local.

    --system        Install for everybody. Default for root.
                    Alias for --prefix /usr/local.

    --suffix S      Append -S to the names of installed files and
                    directories. This allows to install several
                    versions of Opera side by side.

    --force         Ignore all kinds of errors and try to continue.

    --repackage R   Special mode for package maintainers. Extract files
                    into the staging directory R as if it were the
                    installation prefix, but prepare them to be
                    installed under the actual prefix. In this mode, no
                    finalizing actions, such as registration of menu
                    entries, are performed. Sanity checks are disabled.
                    Implies --unattended.

    --version       Show Opera version.

    --help          Show this message.
EOF
}

check_os()
{
	local name version arch res msg
	res=false
	name=$(uname -s)
	case "$name" in
		Linux)
			res=true
			;;
		*BSD)
			;;
	esac
	arch=$(uname -m)
	case "$arch" in
		i?86|i86pc)
			arch=i386
			;;
		amd64)
			arch=x86_64
			;;
	esac
	if [ "$arch" != i386 ]
	then
		res=false
	fi
	if ! $res
	then
		msg="You are running $name on $arch, but this package is intended for Linux on i386. If you choose to install it, the product may not work correctly."
		if $interactive
		then
			ui_warn "$msg"
		else
			ui_error "$msg"
		fi
	fi
}


install_file()
{
	local source dest existing tomake
	if [ -f $tempdir/damaged ] && ! $force
	then
		return 1
	fi
	source=$(use_suffix '' "$3")
	dest=$INTO/$(use_suffix "$SUFFIX" "$3")
	existing=$dest
	tomake=''
	while [ -n "$existing" -a ! -e "$existing" ]
	do
		tomake=$existing
		existing=${existing%/*}
	done
	if [ ! -d "$existing" -o "$dest" = "$existing" ]
	then
		if { rm -rf "$existing~" && mv "$existing" "$existing~"; } 2>$tempdir/error || $force
		then
			echo "mv '$existing~' '$existing'" >>$tempdir/rollback
			echo "rm -rf '$existing~'" >>$tempdir/commit
		else
			ui_error "Cannot make a backup copy of $existing -- see detailed error message below." $tempdir/error
			echo "$dest">>$tempdir/damaged
			return 1
		fi
	elif [ -n "$tomake" -a "$tomake" != "$dest" ]
	then
		if mkdir -p "${dest%/*}" 2>$tempdir/error || $force
		then
			echo "rm -rf '$tomake'" >>$tempdir/rollback
		else
			ui_error "Cannot create directory ${dest%/*} -- see detailed error message below." $tempdir/error
			echo "$dest">>$tempdir/damaged
			return 1
		fi
	fi
	case "$1" in
		N?)
			cp "$source" "$dest"
			;;
		L?)
			source=$(use_suffix "$SUFFIX" "$2")
			ln -s "$source" "$dest"
			;;
		P?)
			case "$dest" in
				*.gz)
					gzip -dc "$source" | process >"${dest%.gz}" && gzip -9 "${dest%.gz}"
					;;
				*)
					process <"$source" >"$dest"
					;;
			esac
			;;
		G?)
			generate_file "${source##*/}" | process >"$dest"
			;;
	esac 2>$tempdir/error || $force || {
		ui_error "Cannot install $dest -- see detailed error message below." $tempdir/error
		echo "$dest">>$tempdir/damaged
		return 1
	}
	case "$1" in
		?F)
			chmod 0644 "$dest"
			;;
		?X)
			chmod 0755 "$dest"
			;;
	esac 2>$tempdir/error || $force || {
		ui_error "Cannot install $dest -- see detailed error message below." $tempdir/error
		echo "$dest">>$tempdir/damaged
		return 1
	}
	ui_progress_advance
}

generate_file()
{
	case "$1" in
		opera)
			cat <<'EOF_generate_file'
#!/bin/sh
export OPERA_DIR=${OPERA_DIR:-@@{PREFIX}/share/opera@@{SUFFIX}}
export OPERA_PERSONALDIR=${OPERA_PERSONALDIR:-$HOME/.opera@@{SUFFIX}}
exec @@{PREFIX}/lib/opera@@{SUFFIX}/opera@@{SUFFIX} "$@"
EOF_generate_file
			;;
		opera-widget-manager)
			cat <<'EOF_generate_file'
#!/bin/sh
exec @@{PREFIX}/bin/opera@@{SUFFIX} --widgetmanager "$@"
EOF_generate_file
			;;
		uninstall-opera)
			sed -ne '1,/EOF_COMMON/p' "${0##*/}"
			cat <<EOF
PREFIX='$PREFIX'
SUFFIX='$SUFFIX'
EOF
			cat <<'EOF_generate_file'

usage()
{
	version
	cat <<EOF

Options:
    --text          Select plaintext user interface
    --unattended    Ask no questions
    --quiet         Ask no questions and don't show progress (implies --text)
    --force         Ignore all kinds of errors and try to continue
    --help          Show this message
EOF
}

uninstall_file()
{
	if $upgrade_mode
	then
		mv "$PREFIX/$3" "$PREFIX/$3~"
		echo "mv '$PREFIX/$3~' '$PREFIX/$3'" >>$install_tempdir/rollback
		echo "rm -f '$PREFIX/$3~'; rmdir -p '$PREFIX/${3%/*}' 2>/dev/null" >>$install_tempdir/commit
	else
		rm -f "$PREFIX/$3"
		rmdir -p "$PREFIX/${3%/*}" 2>/dev/null
	fi
	ui_progress_advance
}

common_init
ui_init 'Uninstalling Opera'

upgrade_mode=false

while [ -n "$1" ]
do
	common_opt "$1" || case "$1" in
		--upgrade)
			shift
			upgrade_mode=true
			talk=false
			interactive=false
			driver=plain
			force=true
			install_tempdir="$1"
			;;
		*)
			driver=plain
			usage
			exit
			;;
	esac
	shift
done

if $talk
then
	msg="This script uninstalls Opera 11.01 build 1175 for Linux on i386 installed as $PREFIX/bin/opera$SUFFIX."
	if $interactive
	then
		ui_warn "$msg"
	else
		ui_message "$msg"
	fi
fi

if [ ! -w $PREFIX ] && ! $force
then
	ui_error "You do not have write permissions for $PREFIX. Perhaps you should be uninstalling as root?"
fi

ui_progress_begin "Removing files"
iterate uninstall_file
ui_progress_end

if ! $upgrade_mode
then
	if $talk
	then
		ui_info "Finalizing uninstallation..."
	fi
	finalize_desktop
fi

if $talk
then
	ui_message "Opera has been uninstalled successfully. However, users' profile directories, which are by default ~/.opera$SUFFIX, have been left intact. You might want to delete them manually."
fi
EOF_generate_file
			;;
		*)
			return 1
	esac
}

rollback()
{
	ui_progress_begin "Undoing installation"
	iterate rollback_file
	ui_progress_end
	if [ -f $tempdir/rollback ]
	then
		. $tempdir/rollback
	fi
}

rollback_file()
{
	local dest
	dest=$INTO/$(use_suffix "$SUFFIX" "$3")
	rm -f "$dest"
	while [ -n "$dest" ]
	do
		dest=${dest%/*}
		case "$dest" in
			$INTO/*/opera*)
				rmdir "$dest" 2>/dev/null || break
				;;
		esac
	done
	ui_progress_advance
}

verify_file()
{
	local md5 file
	md5="$2"
	file=$(use_suffix '' "$3")
	case "$1" in
		[GL]?)
			return
			;;
	esac
	if [ ! -f "$file" ]
	then
		make_tempdir
		echo "$file" >>$tempdir/damaged
	elif [ -n "$md5prog" ]
	then
		if [ $(get_md5 "$file") != "$md5" ]
		then
			echo "$file" >>$tempdir/damaged
		fi
	fi
	ui_progress_advance
}

get_md5()
{
	if [ "$md5prog" = md5 ]
	then
		md5 -q "$1"
	else
		md5sum "$1" | { read sum file; echo $sum; }
	fi
}

use_suffix()
{
	echo "$2" | sed -e "s:@@{SUFFIX}:$1:g"
}

process()
{
	sed -e "s:@@{PREFIX}:$PREFIX:g;s:@@{SUFFIX}:$SUFFIX:g;s:@@{_SUFFIX}:$_SUFFIX:g;s:@@{USUFFIX}:$USUFFIX:g"
}

PREFIX=''
SUFFIX=''
_SUFFIX=''
USUFFIX=''
INTO=''
orig_pwd=$PWD

cd "${0%/*}"

common_init
ui_init 'Installing Opera'

if available md5
then
	md5prog=md5
elif available md5sum
then
	md5prog=md5sum
else
	md5prog=''
fi

while [ -n "$1" ]
do
	common_opt "$1" || case "$1" in
		--user)
			PREFIX=$HOME/.local
			;;
		--system)
			PREFIX=/usr/local
			;;
		--prefix)
			shift
			PREFIX="$1"
			;;
		--suffix)
			shift
			SUFFIX="$1"
			;;
		--repackage)
			shift
			INTO="$1"
			repackage=true
			interactive=false
			driver=plain
			case "$INTO" in
				'')
					ui_error "--repackage needs a non-empty argument."
					;;
				/*)
					;;
				*)
					INTO=$orig_pwd/$INTO
					;;
			esac
			;;
		--version)
			driver=plain
			version
			exit
			;;
		*)
			driver=plain
			usage
			exit
			;;
	esac
	shift
done

if $talk
then
	version
fi

if ! $interactive && [ -z "$PREFIX" ]
then
	ui_error "Please specify --prefix, --user or --system for unattended installation."
fi

if ! $force && ! $repackage
then
	check_os
fi

if [ $(id -u) -eq 0 ]
then
	prefix_who="running as root"
	prefix_for="for all users"
	prefix_default=/usr/local
else
	prefix_who="not running as root"
	prefix_for="just for yourself"
	prefix_default=$HOME/.local
fi

while true
do
	if [ -n "$PREFIX" ]
	then
		answer=$PREFIX
		bad_answer=ui_error
	elif $interactive
	then
		ui_input "Please choose an installation directory. Opera will be installed in bin, share and lib directories under the specified location.

Since you are $prefix_who, you probably want to install Opera $prefix_for. The recommended installation prefix in this case is $prefix_default.

Press Enter to accept the recommended location, or specify a different prefix." || exit
		if [ -z "$answer" ]
		then
			answer=$prefix_default
		fi
		bad_answer=ui_message
	else
		ui_warn "Since you are $prefix_who, assuming you want to install Opera $prefix_for. Using $prefix_default as the installation prefix."
		answer=$prefix_default
		bad_answer=ui_error
	fi
	case "$answer" in
		''|[!/]*)
			$bad_answer "The installation prefix must begin with a slash."
			continue
			;;
		*' '*)
			$bad_answer "The installation prefix is not allowed to contain whitespace."
			continue
			;;
	esac
	while [ $answer != / -a "${answer%/}" != $answer ]
	do
		answer=${answer%/}
	done
	if $repackage
	then
		PREFIX=$answer
		break
	fi
	prefix_parent=$answer
	while [ ! -e "$prefix_parent" ]
	do
		prefix_parent=${prefix_parent%/*}
		if [ -z "$prefix_parent" ]
		then
			prefix_parent=/
		fi
	done
	if [ -w $prefix_parent ]
	then
		PREFIX=$answer
		break
	elif [ -d $prefix_parent ]
	then
		$bad_answer "You do not have write permissions for $prefix_parent. Perhaps you should be installing as root?"
	else
		$bad_answer "$prefix_parent is not a directory."
	fi
done

if [ -z "$INTO" ]
then
	INTO=$PREFIX
fi

while true
do
	if [ -n "$SUFFIX" ]
	then
		answer=$SUFFIX
		bad_answer=ui_error
	elif $interactive
	then
		ui_input "You can install Opera with a suffix, so that the installation does not conflict with other installations of Opera you might have. For example, if you specify 11.01 as the suffix, Opera files will be installed under $PREFIX/share/opera-11.01 and $PREFIX/lib/opera-11.01, and you will have to run $PREFIX/bin/opera-11.01 to run it. The default location of your profile directory will then be ~/.opera-11.01. If you want that, please enter the suffix without the leading dash below. Only Latin letters, digits, periods and dashes are allowed.

Accepting the empty default is a safe choice." || exit
		bad_answer=ui_message
	else
		answer=''
	fi	
	case "$answer" in
		*[!-.A-Za-z0-9]*)
			$bad_answer "The installation suffix is only allowed to contain Latin letters, digits, periods and dashes."
			;;
		[-.]*)
			$bad_answer "The installation suffix cannot start with a period or dash."
			;;
		'')
			SUFFIX=''
			_SUFFIX=''
			USUFFIX=''
			break
			;;
		*)
			SUFFIX=-$answer
			_SUFFIX=" $answer"
			USUFFIX=-$(echo $answer | tr a-z A-Z)
			break
			;;
	esac
done

if ! $repackage && [ -f "$INTO/share/opera$SUFFIX/package-id.ini" ]
then
	upgrade_version=$(sed -ne '/^Version=\(.*\)$/s//\1/p' "$INTO/share/opera$SUFFIX/package-id.ini")
	upgrade_build=$(sed -ne '/^Build=\(.*\)$/s//\1/p' "$INTO/share/opera$SUFFIX/package-id.ini")
	if [ -n "$upgrade_version" -a -n "$upgrade_build" ]
	then
		if [ "$upgrade_version" = 11.01 -a "$upgrade_build" = 1175 ]
		then
			msg="The chosen location already contains an installation of Opera 11.01 build 1175. The installer will attempt to refresh it."
		else
			msg="The chosen location contains an installation of Opera $upgrade_version build $upgrade_build. The installer will attempt to upgrade it to version 11.01 build 1175."
		fi
		if $interactive
		then
			ui_warn "$msg"
		elif $talk
		then
			ui_message "$msg"
		fi
	fi
fi

ui_progress_begin "Verifying package"
iterate verify_file
ui_progress_end

if [ -f $tempdir/damaged ] && ! $force
then
	ui_error "The following files are missing or damaged:" $tempdir/damaged
fi

if ! $force && ! $repackage
then
	need_rollback=true
fi

make_tempdir

if ! $repackage && [ -x "$PREFIX/bin/uninstall-opera$SUFFIX" ]
then
	if $talk
	then
		ui_info "Removing old files..."
	fi
	"$PREFIX/bin/uninstall-opera$SUFFIX" --upgrade $tempdir
fi

ui_progress_begin "Installing files"
iterate install_file
ui_progress_end

need_rollback=false

if ! $repackage
then
	if $talk
	then
		ui_info "Finalizing installation..."
	fi
	if [ -f $tempdir/commit ]
	then
		. $tempdir/commit
	fi
	if $talk && [ "$driver" = plain ]
	then
		finalize_desktop
	else
		finalize_desktop >/dev/null 2>&1
	fi
fi

if $talk
then
	if [ -n "$upgrade_version" -a -n "$upgrade_build" ]
	then
		done='upgraded'
	else
		done='installed'
	fi
	if $repackage
	then
		ui_message "Opera has been installed successfully under $INTO as if it were $PREFIX."
	else
		ui_message "Opera has been $done successfully. To start, run $PREFIX/bin/opera$SUFFIX (you might want to add this location to your PATH).

To manage installed Opera Widgets, run $PREFIX/bin/opera-widget-manager$SUFFIX.

To uninstall Opera, run $PREFIX/bin/uninstall-opera$SUFFIX."
	fi
fi
